## wxHtmlDCRenderer

This class can render HTML document into a specified area of a DC. You can use it in your own printing code, although use of wxHtmlEasyPrinting or wxHtmlPrintout is strongly recommended.

Derived from

wxObject

Include files

<wx/html/htmprint.h>

Members

wxHtmlDCRenderer::wxHtmlDCRenderer
wxHtmlDCRenderer::SetDC
wxHtmlDCRenderer::SetFonts
wxHtmlDCRenderer::SetSize
wxHtmlDCRenderer::SetHtmlText
wxHtmlDCRenderer::Render
wxHtmlDCRenderer::GetTotalHeight

### wxHtmlDCRenderer::wxHtmlDCRenderer

wxHtmlDCRenderer()

Constructor.

### wxHtmlDCRenderer::SetDC

void SetDC(wxDC* dc, double pixel_scale = 1.0)

Assign DC instance to the renderer.

pixel_scale can be used when rendering to high-resolution DCs (e.g. printer) to adjust size of pixel metrics. (Many dimensions in HTML are given in pixels -- e.g. image sizes. 300x300 image would be only one inch wide on typical printer. With pixel_scale = 3.0 it would be 3 inches.)

### wxHtmlDCRenderer::SetFonts

void SetFonts(wxString normal_face, wxString fixed_face, const int *sizes = NULL)

Sets fonts. See wxHtmlWindow::SetFonts for detailed description.

See also SetSize.

### wxHtmlDCRenderer::SetSize

void SetSize(int width, int height)

Set size of output rectangle, in pixels. Note that you can't change width of the rectangle between calls to Render! (You can freely change height.)

### wxHtmlDCRenderer::SetHtmlText

void SetHtmlText(const wxString& html, const wxString& basepath = wxEmptyString, bool isdir = true)

Assign text to the renderer. Render then draws the text onto DC.

Parameters

html

HTML text. This is not a filename.

basepath

base directory (html string would be stored there if it was in file). It is used to determine path for loading images, for example.

isdir

false if basepath is filename, true if it is directory name (see wxFileSystem for detailed explanation)

### wxHtmlDCRenderer::Render

int Render(int x, int y, int from = 0, int dont_render = false)

Renders HTML text to the DC.

Parameters

x,y

position of upper-left corner of printing rectangle (see SetSize)

from

y-coordinate of the very first visible cell

dont_render

if true then this method only returns y coordinate of the next page and does not output anything

Returned value is y coordinate of first cell than didn't fit onto page. Use this value as from in next call to Render in order to print multipages document.

Caution!

The Following three methods must always be called before any call to Render (preferably in this order):

- SetDC
- SetSize
- SetHtmlText

Render() changes the DC's user scale and does NOT restore it.

### wxHtmlDCRenderer::GetTotalHeight

int GetTotalHeight()

Returns the height of the HTML text. This is important if area height (see SetSize) is smaller that total height and thus the page cannot fit into it. In that case you're supposed to call Render as long as its return value is smaller than GetTotalHeight's.